import usb.core
import usb.util
import sys,time,string,struct,os
GCNCLIENT = "./gcnclient_rpi"
def parseTokens(s):
	s = s.replace("\xbb\xb0","a")
	s = s.replace("\xbb\xb1","b")
	s = s.replace("\xbb\xb2","c")
	s = s.replace("\xbb\xb3","d")
	s = s.replace("\xbb\xb4","e")
	s = s.replace("\xbb\xb5","f")
	s = s.replace("\xbb\xb6","g")
	s = s.replace("\xbb\xb7","h")
	s = s.replace("\xbb\xb8","i")
	s = s.replace("\xbb\xb9","j")
	s = s.replace("\xbb\xba","k")
	s = s.replace("\xbb\xbc","l")
	s = s.replace("\xbb\xbd","m")
	s = s.replace("\xbb\xbe","n")
	s = s.replace("\xbb\xbf","o")
	s = s.replace("\xbb\xc0","p")
	s = s.replace("\xbb\xc1","q")
	s = s.replace("\xbb\xc2","r")
	s = s.replace("\xbb\xc3","s")
	s = s.replace("\xbb\xc4","t")
	s = s.replace("\xbb\xc5","u")
	s = s.replace("\xbb\xc6","v")
	s = s.replace("\xbb\xc7","w")
	s = s.replace("\xbb\xc8","x")
	s = s.replace("\xbb\xc9","y")
	s = s.replace("\xbb\xca","z")
	s = s.replace("\xbb\xd2","#")
	s = s.replace(":",".")
	return s
def getMessage(message):
	message = struct.pack("<H",len(message))+message
	message = "\x04"+message
	message="\x00\x00\x00\x00\x00\xFF\xFF\xFF\xFF\xFF"+struct.pack("<H",len(message))+message
	#message=struct.pack("<H",len(message)+1)+"b"+message+"*"
	#message=struct.pack("<H",len(message))+message
	print "Created Message "+":".join("{0:x}".format(ord(c)) for c in message)
	return message

while True:
	# find our device
	dev = usb.core.find(idVendor=0x0451, idProduct=0xE003)
	
	# was it found?
	if dev is None:
		dev = usb.core.find(idVendor=0x0451, idProduct=0xE008)
		if dev is None:
			print "No calc found, pausing 5 seconds"
			time.sleep(5)
			continue
	
	# set the active configuration. With no arguments, the first
	# configuration will be the active one
	print "Found Calculator"
	dev.set_configuration()
	
	#dev.write(0x02,'test',0)
	readbuffer = ""
	loop = True
	while loop:
		try:
			data = dev.read(0x81,500)
			readbuffer=readbuffer+''.join([chr(x) for x in data])
			temp=string.split(readbuffer, "\xbb\x4e")
			readbuffer=temp.pop()
			for line in temp:
				print "Recieved Line "+":".join("{0:x}".format(ord(c)) for c in line)
				stuff=line[15:]
				print stuff
				if stuff=="PING":
					print "Sending pong...."
					dev.write(0x02,getMessage("PONG"),0)
				if stuff[:3]=="SET":
					params = string.split(line,"\x80")
					print "Hub:"+parseTokens(params[1])
					print "Name:"+parseTokens(params[2])
					print "Server:"+parseTokens(params[3])
					print "port:"+parseTokens(params[4])
					print "setting stuff...."
					print "replying to calculator...."
					dev.write(0x02,getMessage("SUCCESS"),0)
					time.sleep(1)
					dev.reset()
					shell = GCNCLIENT+" -n '"+parseTokens(params[1])+"' -l '"+parseTokens(params[2])+"' -s '"+parseTokens(params[3])+"' -d d"
					print "executing "+shell
					os.system(shell)
					loop = False			
		except usb.core.USBError as e:
			if e.args[0] == 'Operation timed out':
				continue
			elif e.args[0] == 'Input/output error':
				print "Calculator disconnected."
				break
			else:
				print e.args
